*********************************************
*****PALESTINE: Fiscal Incidence Analysis*********
*****World Bank, Poverty and Equity GP*************
***********TTL: Arden Finn and Alia Jane************

set type double 
set more off 
clear all 

use "${datapath}\PSE\indvweight.dta", clear
ren id00 hhid
merge m:1 hhid using "${datapath}\PSE\PSE_2016_PECS_v01_M_v04_A_MNAPOV_3.dta", keepusing(hhsize gall region)
drop _merge 
ren hhid id00 
lab var id00 "Household ID"
lab var d1 "Personal ID"
lab var weightt "Population weights"
lab var rw "Individual reweight index"

bys id00: egen hhweight = mean(weightt)
lab var hhweight "HH weights derived from individual weights"

qui sum weightt
disp r(sum)   //4.9465153 m individuals - these are the weights that actually match the population. 

qui sum hhweight
disp r(sum)  //4.9465153 m individuals - correct 

count //20,185
save "${temppath}indvweights.dta", replace

keep if d1 == 1 

qui sum hhweight [w=hhsize]
disp r(sum)  // 4946515.3

g popw  = hhweight*hhsize

qui sum popw 
disp r(sum) //4946515.3

tempfile hhweight
ren id00 hhid
save "${temppath}hhweight.dta", replace

*Add id01
use "${datapath}\PSE\cover.dta", clear
sort id00 
ren id00 hhid
merge 1:1 hhid using "${temppath}hhweight.dta"
drop _m
save "${temppath}hhweight_v2.dta", replace

qui sum hhweight [w=hhsize]
global wgttot = r(sum)
disp $wgttot   //4.9465153 m individuals - correct 
assert r(sum) == $wgttot 
