*********************************************
*****PALESTINE: Fiscal Incidence Analysis***********
*****World Bank, Poverty and Equity GP*********
***********TTL: Arden Finn and Alia Jane*****************
*********Consultant: Haydeeliz Carrasco*******
**********************************************
*Date: March 9th, 2022
*Modified: Nov. 17th, 2022


clear
set more off


************************
***IMPORT IO MATRIX****
***********************

clear 
import excel "${io}Augmented IO_West Bank_V3.xlsx", sheet("Augmented IO_STATA") cellrange(A1:Z26) firstrow clear 
rename sector sec

gen fixed = 0
		local fixprice "3 4 6"  //Based on discussion with Maya: IO sectors that with imported share higher than 50% (e.g. tradable price likely not affected by indirect effects: Mining, Petroleum products and electricity)
		
		foreach sec in `fixprice' {
			replace fixed = 1 in `sec'  
		}

		gen dp = 0 // dp=VAT%/(1+VAT %)
			replace dp=-0.16/(1+0.16) if sec==2 | sec==3 | sec==4 | sec==5 | sec==6 | sec==8 | sec==9 | sec==10 | sec==12 | sec==14 | sec==15 | sec==17 | sec==19 | sec==22 | sec==24 | sec==25
			
		costpush sector*, fixed(fixed) price(dp) genptot(totalfix) genpind(indirectfix) fix
		list totalfix indirectfix

	
		keep sec indirectfix totalfix
		rename sec sector
		sort sector

		
		
save "${temppath}PSE_VAT_IO indeff.dta", replace

sum indirectfix //average indirect effect=3.9% 





























