* Palestine Fiscal Incidence Analysis
* E-Section Output Tables 
* Maya Goldman
* 16th June 2021 


* Generate input locals 


use "${outputpath}etabs.dta", clear

		loc ppp = 1
		loc cpibase = 1
		loc cpisurvey = 1
		disp `ppp'*(`cpisurvey'/`cpibase')  //0.735 

		loc ppplist ppp(`ppp') cpibase(`cpibase') cpisurvey(`cpisurvey') 
		loc surveylist hsize(hhsize) // psu(cluster) strata(strata)
		loc povlist pl1(1.9) pl2(3.2) pl3(5.5) nationalm(pl_nat)  // nationalm(XXX) othere(XXX)   
		loc cutlist cut1(1.9) cut2(3.2) cut3(5.5) cut4(11.50) cut5(57.50)
		loc titlelist country("Palestine") surveyyear(2017) scen("PGT") project("WB") authors("Arden, Beenish, Haydeeliz, Maya")



* Income concept options *

		loc inclist_pdi 	m(yl_pc) mp(yp_pc) n(yn_pc) g(yg_pc) d(yd_pc) c(yc_pc) f(yf_pc)
		loc inclist_pgt 	m(ym_pc) mp(ye_pc) n(yk_pc) g(yr_pc) d(yd_pc) c(yc_pc) f(yf_pc)
		loc dtrlist     	dtransfers(dtr_cash_pc dtr_inkd_pc)
		loc dtxlist			dtaxes(dtx_pitx_plst_pc dtx_pitx_isrl_pc dtx_prop_buil_pc dtx_prop_land_pc)
		loc conlist			contribs(con_pens_pc con_pens_isrl_pc)
		loc itxlist			indtaxes(itx_vati_pc itx_vatd_pc itx_cusx_pc)
		loc sublist			sub(sub_elec_pc sub_fuel_pc)
		loc hltlist 		health(hlt_hosp_pc hlt_ambl_pc)
		loc edulist 		educ(edu_prim_pc edu_seco_pc)
		loc fisclist  	 	`dtrlist' `dtxlist' `conlist' `itxlist' `sublist' `hltlist' `edulist'
		*loc paytaxes		paydtaxes(dtx_paye_pi dtx_sdlv_pi) paycontribs(con_uifd_pi con_cmpf_pi) payindtax(itx_tvat_ph itx_excs_ph itx_tfuel_ph)
 		*loc dbmarkersb  	recdtransfers(dtr_olda_ri dtr_disb_ri dtr_chds_ri dtr_depn_ri dtr_fost_ri dtr_hous_ri dtr_fbs_ri ) `paytaxes' 

 		 		
		loc ceqdes    		= 0 	// E1
		loc ceqpop    		= 0 	// E2
		loc ceqextpop 		= 0 	// E2b
		loc ceqlorenz 		= 0 	// E3
		loc ceqfi     		= 1 	// E5, E6
		loc ceqef     		= 0 	// E9
		loc ceqconc   		= 0 	// E10
		loc ceqfiscal 		= 0 	// E11
		loc ceqextend		= 0		// E12
		loc ceqmarg			= 0		// E13
		loc ceqefext		= 0		// E14
		loc ceqcoverage		= 0		// E18
		loc ceqgraphprog	= 0		// E24  
		loc ceqgraphconc	= 0		// E25 
		loc ceqgraphcdf		= 0		// E26
		loc ceqgraphfi		= 0		// E27


foreach scn in pgt{

	svyset cluster [pw=hhweight], strata(strata)

* Produce the etabs 

		if `ceqdes'{
				ceqdes using "${mwbe_`scn'}MWB2018_E1_March29_2018.xlsx", `inclist_`scn'' `fisclist' `surveylist' `titlelist' 
			}

		if `ceqpop'{
				ceqpop using "${mwbe_`scn'}MWB2018_E2_March29_2018.xlsx", `inclist_`scn'' `ppplist' `surveylist' `cutlist' `titlelist'
			}

		if `ceqlorenz'{
				ceqlorenz using "${mwbe_`scn'}MWB2018_E3_March29_2018.xlsx", `inclist_`scn'' `ppplist' `surveylist' `povlist' `cutlist' `titlelist'
			}

		if `ceqfi'{
				ceqfi using "${mwbe_`scn'}MWB2018_E5E6_March29_2018.xlsx" [pw=hhweight], `inclist_`scn'' `ppplist' `surveylist' `povlist' `titlelist'
			}

		
/* This command still not working when I checked on 13th Sep 2021. It is running the results from E1 into the E9 tab. 

		if `ceqef'{
				ceqdes using "${mwbe_`scn'}MWB2018_E9_March29_2018.xlsx", `inclist_`scn'' `fisclist' `surveylist' `titlelist' 
			}

*/
		if `ceqconc'{
				ceqconc using "${mwbe_`scn'}MWB2018_E10_March29_2018.xlsx", noc nob `inclist_`scn'' `ppplist' `surveylist' `cutlist' `titlelist'
			}

		if `ceqfiscal'{
				ceqfiscal using "${mwbe_`scn'}MWB2018_E11_March29_2018.xlsx", noc nob negatives `inclist_`scn'' `fisclist' `ppplist' `surveylist' `cutlist' `titlelist'
			}

		if `ceqextend'{
				ceqextend using "${mwbe_`scn'}MWB2018_E12_March29_2018.xlsx", noc nob negatives `inclist_`scn'' `fisclist' `ppplist' `surveylist' `povlist' `cutlist' `titlelist'
			}

		if `ceqmarg'{
				ceqmarg using "${mwbe_`scn'}MWB2018_E13_March29_2018.xlsx", negatives `inclist_`scn'' `fisclist' `ppplist' `surveylist' `povlist' `titlelist'
			}

		if `ceqefext'{
				ceqefext using "${mwbe_`scn'}MWB2018_E14_March29_2018.xlsx", `inclist_`scn'' `fisclist' `ppplist' `surveylist' `povlist' `cutlist' `titlelist'
			}

		if `ceqcoverage'{
				ceqcoverage using "${mwbe_`scn'}MWB2018_E18_March29_2018.xlsx", `inclist_`scn'' `fisclist' `ppplist' `surveylist' `cutlist' `titlelist' `dbmarkers'
			}

/*		if `ceqgraphprog'{
				ceqgraph progressivity using "${mwbe_`scn'}MWB_E24.xlsx", market(ym_c_pc) mpluspensions(yp_c_pc) consumable(yc_c_pc) final(yf_c_pc) `surveylist' path("${graphs}\") `titlelist'  		//MG: it seems like this has to be the same folder that the Etab is saved in otherwise this doesn't work.  
			}

		if `ceqgraphconc'{
				ceqgraph conc using "${mwbe_`scn'}\MWB_E25.xlsx", `inclist_`scn'' `fisclist' `surveylist' path("${graphs}\") `titlelist'
			}

		if `ceqgraphcdf'{
				ceqgraph cdf using "${mwbe_`scn'}\MWB_E26.xlsx", `inclist_`scn'' `ppplist' `surveylist' path("${graphs}\") `titlelist'
			}

		if `ceqgraphfi'{
				ceqgraph fi using "${mwbe_`scn'}MWB_E27.xlsx", `inclist_`scn'' `ppplist' `surveylist' path("${graphs}\") `titlelist'
			}*/

}

